#include "buffer.h"

/**
 * $Id: buffer_getchar.c 374 2010-12-22 12:23:12Z fbergmann $
 */

int buffer_getchar(buffer *b) {
  register char *p;
  register ssize_t l;

  if (!b) return EOF;
  p = b->c;
  if (!p) return EOF;
  if (p < b->t) goto get;

  p = b->s;
  l = read(0, p, b->l);
  if (l <= 0) {
    b->c = 0; /* EOF */
    if (l < 0) return -2;
    return EOF;
  }
  b->t = p + l;

  get:
  b->c = p + 1;
  return (int) (unsigned char) (*p);
}
