#include "griller.h"

void get_envvars() {
  register char *p;
  uint32_t val32;

  p = getenv("KILL_LEVEL");
  if (!p || !str2uint32(p, &val32)) {
    kill_level = 3600; /* seconds */
  } else {
    kill_level = val32;
  }
  p = getenv("MINUID");
  if (p && str2uint32(p, &val32)) {
    min_uid = val32;
  }
  p = getenv("MAXUID");
  if (p && str2uint32(p, &val32)) {
    max_uid = val32;
  }
  p = getenv("KILLING_OFF");
  if (!p) {
    killing_off = 0;
  } else {
    killing_off = 1;
  }
  p = getenv("MAXLOADSOFT");
  if (!p || !str2uint32(p, &val32)) {
    maxloadsoft = 40;
  } else {
    maxloadsoft = val32;
  }
  p = getenv("MAXLOADHARD");
  if (!p || !str2uint32(p, &val32)) {
    maxloadhard = 60;
  } else {
    maxloadhard = val32;
  }
  p = getenv("PROCSOFTLIMIT");
  if (!p || !str2uint32(p, &val32)) {
    procsoftlimit = 15;
  } else {
    procsoftlimit = val32;
  }
  p = getenv("PROCHARDLIMIT");
  if (!p || !str2uint32(p, &val32)) {
    prochardlimit = 45;
  } else {
    prochardlimit = val32;
  }
  return;
}
