#include "buffer.h"

/**
 * $Id: buffer_flush.c 374 2010-12-22 12:23:12Z fbergmann $
 */

int buffer_flush(buffer *b) {
  register char *p;
  ssize_t bytes;

  if (!b) return 1;
  p = b->s;
  if (p == b->c) return 0;
  for (;;) {
    bytes = write(b->fd, p, b->c - p);
    if (bytes == -1) return 1;
    p += bytes;
    if (p == b->c) break;
  }
  b->c = b->s;
  return 0;
}
