#include "buffer.h"

/**
 * $Id: buffer_putstr.c 374 2010-12-22 12:23:12Z fbergmann $
 */

int buffer_putstr(buffer *b, register const char *a) {
  register char *p;
  register char *s;
  register const char *t;
  register uint32_t l;

  if ((!a) || (!b)) return -1;
  l = strlen(a);
  if (!l) return 0;
  p = b->c;
  t = b->t;
  if ((p + l) <= t) goto put;

  s = b->s;
  if (write(1, s, p-s) < 0) return -1;
  p = s;
  if ((p + l) > t) {
    b->c = p;
    return write(1, a, l);
  }

  put:
  t = a + l;
  for(;;) {
    *p = *a; ++p; ++a; if (a >= t) break;
    *p = *a; ++p; ++a; if (a >= t) break;
    *p = *a; ++p; ++a; if (a >= t) break;
    *p = *a; ++p; ++a; if (a >= t) break;
  }
  b->c = p;
  return 0;
}
